/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include <config.h>

#include "IOOverheadTest.h"

using namespace advisor;


IOOverheadTest::IOOverheadTest( cube::CubeProxy* cube ) : PerformanceTest( cube )
{
    setName( tr( "I/O Overhead" ).toUtf8().data() );
    setWeight( 0.2 );   // need to be adjusted
    setValue( 0 );
}

void
IOOverheadTest::applyCnode( const cube::Cnode* cnode, const cube::CalculationFlavour cnf  )
{
    setValue( 0 );
}

void
IOOverheadTest::applyCnode( const cube::list_of_cnodes& cnodes )
{
    setValue( 0 );
}


const std::string&
IOOverheadTest::getCommentText() const
{
    return no_comment;
}


// ------ overview tests ---------

bool
IOOverheadTest::isActive() const
{
    return false;
};

bool
IOOverheadTest::isIssue() const
{
    return false;
};
